/* DO NOT EDIT THIS FILE - it is machine generated */
#include <jni.h>
/* Header for class android_serialport_SerialPort */

#ifndef __SERIALPORT_H__
#define __SERIALPORT_H__

#include <termios.h>
#include <time.h>

inline void set_baudrate (struct termios *opt, unsigned int baudrate)
{
    cfsetispeed(opt, baudrate);
    cfsetospeed(opt, baudrate);
}

inline void set_data_bit (struct termios *opt, unsigned int databit)
{
    opt->c_cflag &= ~CSIZE;
    switch (databit)
    {
        case 8:
            opt->c_cflag |= CS8;
            break;
        case 7:
            opt->c_cflag |= CS7;
            break;
        case 6:
            opt->c_cflag |= CS6;
            break;
        case 5:
            opt->c_cflag |= CS5;
            break;
        default:
            opt->c_cflag |= CS8;
            break;
    }
}

inline void set_parity (struct termios *opt, char parity)
{
    switch (parity)
    {
        case 'N':/* 无校验 */
        case 'n':
            opt->c_cflag &= ~PARENB;
            break;
        case 'E':/*偶校验*/
        case 'e':
            opt->c_cflag |= PARENB;
            opt->c_cflag &= ~PARODD;
            break;
        case 'O':/* 奇校验 */
        case 'o':
            opt->c_cflag |= PARENB;
            opt->c_cflag |= ~PARODD;
            break;
        default: /*其它选择为无校验 */
            opt->c_cflag &= ~PARENB;
            break;
    }
}

inline void set_stopbit (struct termios *opt, const int stopbit)
{
    switch (stopbit)
    {
        case 10:
            opt->c_cflag &= ~CSTOPB;/*1 位停止位 t */
            break;
        case 15:
            opt->c_cflag &= ~CSTOPB;/*1.5 位停止位 */
            break;
        case 20:
            opt->c_cflag |= CSTOPB; /*2 位停止位 */
            break;
        default:
            opt->c_cflag &= ~CSTOPB; /*1 位停止位 */
            break;
    }
}

inline int64_t get_msec()
{
    struct timeval tv;
    int64_t time_in_msec = 0;

    gettimeofday(&tv, NULL);
    time_in_msec = tv.tv_sec;
    time_in_msec *= 1000;
    time_in_msec += tv.tv_usec / 1000;

    return time_in_msec;
}

class CSerialPort
{
public:
    CSerialPort();
    ~CSerialPort();
    bool Open(const char* path, speed_t baudrate, int dataBits, int stopBits, int parity, int vtime, int vmin);

    void  Close();

    int SetAttributes(unsigned int baudrate, int databit, int stopbit, char parity, int vtime, int vmin);

    size_t Send(const uint8_t* data, size_t dataLength);
    size_t Recv(uint8_t* data, size_t dataLength);

private:

    int fd;
};

#endif // __SERIALPORT_H__
